// VCDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VCDemo.h"
#include "VCDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVCDemoDlg dialog

CVCDemoDlg::CVCDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVCDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVCDemoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	start = FALSE;
}

void CVCDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVCDemoDlg)
	DDX_Control(pDX, IDC_EDIT1, Label1);
	DDX_Control(pDX, IDC_FUEL, FUEL);
	DDX_Control(pDX, IDC_OIL, OIL);
	DDX_Control(pDX, IDC_RPM, RPM);
	DDX_Control(pDX, IDC_SPEED, SPEED);
	DDX_Control(pDX, IDC_VOLTS, VOLTS);
	DDX_Control(pDX, IDC_WATER, WATER);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVCDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CVCDemoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCDemoDlg message handlers

BOOL CVCDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	init_values();
	Label1.SetWindowText("");
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVCDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVCDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CVCDemoDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CVCDemoDlg)
	ON_EVENT(CVCDemoDlg, IDC_FUEL, -601 /* DblClick */, OnDblClickFuel, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_OIL, -601 /* DblClick */, OnDblClickOil, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_RPM, -601 /* DblClick */, OnDblClickRpm, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_SPEED, -601 /* DblClick */, OnDblClickSpeed, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_VOLTS, -601 /* DblClick */, OnDblClickVolts, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_WATER, -601 /* DblClick */, OnDblClickWater, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

BOOL CVCDemoDlg::DestroyWindow() 
{
	if (start) {
		KillTimer(1000);
		}
	
	return CDialog::DestroyWindow();
}

void CVCDemoDlg::OnTimer(UINT nIDEvent) 
{
	switch (nIDEvent) {
		case 1000:
		    FUEL.SetValue(FUEL.GetValue() - 0.004f);
			
			if (FUEL.GetValue() <= 0.0f) {
				Label1.SetWindowText("Out of GAS!");
				KillTimer(1000);
				start = FALSE;
				
				init_values();
				break;
				}
			
			RPM.SetValue(RPM.GetValue() + tachinc);
			SPEED.SetValue(SPEED.GetValue() + speedinc);
			
			if (RPM.GetValue() > 7.0f && gear < 4) {
				RPM.SetValue(3.0f);
				gear++;
				}
			else if (RPM.GetValue() > 7) 
				RPM.SetValue(7.0f);
			
			if (SPEED.GetValue() > 130.0f) 
				SPEED.SetValue(130.0f);
			
			if (OIL.GetValue() > 60.0f) 
				OIL.SetValue(60.0f);
			
			VOLTS.SetValue(VOLTS.GetValue() + voltinc);
			
			if (VOLTS.GetValue() > 13.5f) 
				voltinc = -0.4f;
    
			if (VOLTS.GetValue() < 10.0f) 
				voltinc = 0.4f;
			
			WATER.SetValue(WATER.GetValue() + tempinc);
			if (WATER.GetValue() > 230.0f) 
				tempinc = -1.0f;
			
			if (WATER.GetValue() > 200.0f && WATER.GetValue() < 230.0f) 
				tempinc = 1.0f;
			
			OIL.SetValue(OIL.GetValue() + oilinc);
			if (OIL.GetValue() > 47.0f) 
				OIL.SetValue(47.0f);
			
			break;
		}
	
	CDialog::OnTimer(nIDEvent);
}

void CVCDemoDlg::OnDblClickFuel() 
{
	FUEL.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickOil() 
{
	OIL.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickRpm() 
{
	RPM.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickSpeed() 
{
	SPEED.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickVolts() 
{
	VOLTS.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickWater() 
{
	WATER.ShowPropertyPage();
}

void CVCDemoDlg::OnButton1() 
{
	if (!start) {
		SetTimer(1000,50,NULL);
		start = TRUE;
		
		Label1.SetWindowText("");
        
        SPEED.SetValue(0.0f);
        RPM.SetValue(1.0f);
        OIL.SetValue(15.0f);
        FUEL.SetValue(1.0f);
        WATER.SetValue(100.0f);
        VOLTS.SetValue(11.0f);
        gear = 1;
		}
	
}


void CVCDemoDlg::init_values()
{
    voltinc = 0.05f;
    speedinc = 0.4f;
    oilinc = 0.1f;
    tachinc = 0.05f;
    tempinc = 0.2f;

    RPM.SetValue(0.0f);
    SPEED.SetValue(0.0f);
    FUEL.SetValue(1.0f);
    OIL.SetValue(0.0f);
    WATER.SetValue(100.0f);
    VOLTS.SetValue(6.0f);
}

